//  Данный пример демонстрирует ответ на входящий голосовой вызов:
//  ==========================================================================================
    #include <iarduino_GSM.h>                                                                 // Подключаем библиотеку iarduino_GSM для работы с GSM/GPRS Shield.
    iarduino_GSM gsm;                                                                         // Создаём объект gsm для работы с функциями и методами библиотеки iarduino_GSM.
                                                                                              //
//  Следующие 2 строки нужны для работы по программной шине UATR (выводы 7 и 8):              //
    #include <SoftwareSerial.h>                                                               // Подключаем библиотеку SoftwareSerial для программной реализации шины UART.
    SoftwareSerial softSerial(7,8);                                                           // Создаём объект softSerial указывая выводы RX и TX платы Arduino.
//  Если Вы работаете c GSM/GPRS Shield по аппаратной шине UATR, удалите 2 предыдущие строки, //
//  а в функции gsm.begin(), вместо softSerial укажите Serial или Serial1, Serial2 ...        // Зависит от номера аппаратной шины UART использующей выводы 0 и 1 Вашей платы Arduino.
                                                                                              //
void setup(){                                                                                 //
//  Выводим текст в монитор последовательного порта:                                          //
    Serial.begin(9600);                                                                       // Инициируем передачу данных по аппаратной шине UART для вывода результата в монитор последовательного порта.
    Serial.print( F("Initialization, please wait ... ") );                                    // Выводим текст.
                                                                                              //
//  Инициируем GSM/GPRS Shield и проверяем его готовность к работе:                           //
    gsm.begin(softSerial);                                                                    // Инициируем работу GSM/GPRS Shield, указывая объект шины UART.
    while(gsm.status()!=GSM_OK){Serial.print("."); delay(1000);} Serial.println(" OK!");      // Ждём завершения регистрации модема в сети оператора связи.
    Serial.println( F("--------------------") );                                              //
}                                                                                             //
                                                                                              //
void loop (){                                                                                 //
//  Если есть входящий вызов:                                                                 //  
    if(gsm.CALLavailable()){                                                                  // Функция CALLavailable() возвращает true если есть входящий дозванивающийся вызов. В качестве аргумента функции можно указать строку в которую будет записан адрес (номер) вызывающего абонента.
        Serial.println( "Incoming call" );                                                    // Входящий вызов.
        gsm.CALLup();                                                                         // Отвечаем на вызов. Если нужно сбросить вызов, то обращаемся к функции CALLend().
//      Ждём перехода входящего вызова в разряд активных:                                     // Это не даст многократно ответить на один и тот же входящий вызов.
        while(gsm.CALLavailable()){}                                                          // Цикл выполняется пока есть входящий дозванивающийся вызов ...
    }   delay(1000);                                                                          // Выполняем задержку в 1 секунду.
}                                                                                             //
                                                                                              //
/*  Примечание:
 *  ==========================================================================================
 *  Перед ответом можно проверить номер телефона в строке num, таким образом отвечать только указанным абонентам.
 *  Если номер не требуется узнавать или сверять, то функцию CALLavailable() можно оставить без параметра, а строку num не объявлять.
 *  Проверку статуса соединения можно опустить, как это сделано в примере call_incoming_mini.
 *  В данном примере не реализован разрыв голосового соединения функцией CALLend() во время разговора, см. пример all.
 *  Во время разговора используется громкая связь, для переключения на гарнитуру и обратно воспользуйтесь функцией SOUNDdevice(), см. пример all.
 */